VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmMatrizAg 
   Caption         =   "Matriz de agujeros"
   ClientHeight    =   6645
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6405
   OleObjectBlob   =   "frmMatrizAg.frx":0000
   StartUpPosition =   1  'Centrar en propietario
End
Attribute VB_Name = "frmMatrizAg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Public oDoc As PartDocument
Public oCara As Face
Public oUOM As UnitsOfMeasure

Private Sub cmdAceptar_Click()
Dim oBoceto As PlanarSketch
'Set oDoc = ThisApplication.ActiveDocument
Set oBoceto = oDoc.ComponentDefinition.Sketches.Add(oCara, False)

Dim oTrans As TransientGeometry
Set oTrans = ThisApplication.TransientGeometry

Dim oPuntos As SketchPoints
Set oPuntos = oBoceto.SketchPoints
Dim oCentrosAgujeros As ObjectCollection
Set oCentrosAgujeros = ThisApplication.TransientObjects.CreateObjectCollection

Dim ptX As Double
Dim ptY As Double
Dim pto As Point2d

Dim i As Integer
i = 0
Dim j As Integer
j = ((txtCant.Value) - 1)

Err.Clear
On Error Resume Next

Do While (i <= j)
    i = 1 + i
    ptX = oUOM.GetValueFromExpression(txtRad.Text, kDefaultDisplayLengthUnits) * Cos((i - 1) * (6.2831853 / (j + 1)))
    ptY = oUOM.GetValueFromExpression(txtRad.Text, kDefaultDisplayLengthUnits) * Sin((i - 1) * (6.2831853 / (j + 1)))
    Call oCentrosAgujeros.Add(oPuntos.Add(oTrans.CreatePoint2d(ptX, ptY), True))
Loop

Dim dblDiam As Double
Dim dblProf As Double
dblProf = oUOM.GetValueFromExpression(txtProf.Text, kDefaultDisplayLengthUnits)
dblDiam = oUOM.GetValueFromExpression(txtDiam.Text, kDefaultDisplayLengthUnits)

Call oDoc.ComponentDefinition.Features.HoleFeatures.AddDrilledByDistanceExtent _
(oCentrosAgujeros, dblDiam, dblProf, kPositiveExtentDirection)

If Err.Number <> 0 Then
    MsgBox Err.Description
End If
Unload Me
End Sub

Private Sub cmdCancelar_Click()
    Unload Me
End Sub

Private Sub cmdConfirmar_Click()
    Dim strMsj As String
    strMsj = ""
    Dim dblDiaTotal As Double
    dblDiaTotal = _
        oUOM.GetValueFromExpression(txtDiam.Text, kDefaultDisplayLengthUnits) + _
        (2 * oUOM.GetValueFromExpression(txtRad.Text, kDefaultDisplayLengthUnits))
    Dim dblDistCtr As Double
    dblDistCtr = _
        2 * (oUOM.GetValueFromExpression(txtRad.Text, kDefaultDisplayLengthUnits) * _
        Sin(3.1416 / txtCant.Value))
    Dim dblDiaAgujero As Double
    dblDiaAgujero = oUOM.GetValueFromExpression(txtDiam.Text, kDefaultDisplayLengthUnits)
    If (dblDiaTotal > oCara.Edges.Item(1).Geometry.Radius * 2) Then
            strMsj = "Los agujeros se saldrn de la pieza," & vbCrLf & "Datos;" & vbCrLf & _
            "Dimetro externo de la matriz propuesta:" & _
            oUOM.GetStringFromValue(dblDiaTotal, kDefaultDisplayLengthUnits) & vbCrLf & _
            "Dimetro de la Pieza: " & oUOM.GetStringFromValue(oCara.Edges.Item(1).Geometry.Radius * 2, kDefaultDisplayLengthUnits)
    End If
    If dblDistCtr <= dblDiaAgujero Then
            strMsj = strMsj & vbCrLf & _
            "Los agujeros se solaparn." & vbCrLf & "Datos:" & vbCrLf & _
            "Distancia entre agujeros:" & dblDistCtr & vbCrLf & _
            "Dimetro de los agujeros: " & frmMatrizAg.txtDiam.Text
    End If
    If strMsj = "" Then
        cmdAceptar.Enabled = True
        lblInfo.Caption = "Dimensiones aceptadas." & vbCrLf & "Pulse Aplicar para terminar."
    Else
        cmdAceptar.Enabled = False
        lblInfo.Caption = strMsj
    End If
End Sub

Private Sub cmdSeleccionar_Click()
        Set oUOM = oDoc.UnitsOfMeasure
        Dim oSelecc As New clsSeleccionar
        oSelecc.Filtro = kPartFaceFilter
        oSelecc.Mensaje = "seleccione una cara"
        Me.hide
        Set oCara = oSelecc.Designa(1)
        If oCara.Edges.Count = 1 And oCara.Edges.Item(1).CurveType = kCircleCurve Then
            txtCant.Enabled = True
            lblCant.Enabled = True
            txtRad.Enabled = True
            lblRad.Enabled = True
            txtDiam.Enabled = True
            lblDiam.Enabled = True
            txtProf.Enabled = True
            lblProf.Enabled = True
            
            Dim dblRadio As Double
            Dim dblRadMat As Double
            Dim dblDiam As Double
            ' se establecen valores por defecto calculados a partir de las dimensiones de la cara.
            txtCant.Value = 6
            dblRadio = oCara.Edges.Item(1).Geometry.Radius
            dblRadMat = dblRadio * 2 / 3
            dblDiam = 3.1416 * dblRadMat / 6
            If dblDiam > 1 Then
                dblDiam = Fix(dblDiam)
            End If
            txtRad.Text = oUOM.GetStringFromValue(dblRadMat, kDefaultDisplayLengthUnits)
            txtDiam.Text = oUOM.GetStringFromValue(dblDiam, kDefaultDisplayLengthUnits)
            txtProf.Text = oUOM.GetStringFromValue(dblDiam * 2, kDefaultDisplayLengthUnits)
            
            Dim dblCentroX As Double
            Dim dblCentroY As Double
            dblCentroX = oCara.Edges.Item(1).Geometry.Center.X
            dblCentroY = oCara.Edges.Item(1).Geometry.Center.Y
            lblInfo.Caption = "Radio de la cara seleccionada: " & _
                oUOM.GetStringFromValue(dblRadio, kDefaultDisplayLengthUnits) & _
                vbCrLf & "Coordenadas locales del centro: (" & _
                oUOM.GetValueFromExpression(dblCentroX, kDefaultDisplayLengthUnits) & _
                "," _
                & oUOM.GetValueFromExpression(dblCentroY, kDefaultDisplayLengthUnits) & ")"
                
            lblInfo.ForeColor = vbBlack
            txtRad.ForeColor = vbBlack
            txtDiam.ForeColor = vbBlack
            txtProf.ForeColor = vbBlack
            cmdConfirmar.Enabled = True
        Else
            lblInfo.ForeColor = vbRed
            lblInfo.Caption = "ERROR: Debe seleccionar una cara plana circular"
            cmdConfirmar.Enabled = False
        End If
        Me.Show
End Sub


Private Sub txtCant_BeforeUpdate(ByVal Cancel As MSForms.ReturnBoolean)
    Err.Clear
    On Error Resume Next
    If (txtCant.Value < 0 Or Err.Number <> 0) Then
        lblInfo.Caption = "La cantidad debe ser un nmero mayor que cero"
        Cancel = True
    Else
        lblInfo.Caption = ""
        Cancel = False
    End If
End Sub

Private Sub txtCant_Change()
    If IsNumeric(txtCant.Value) Then
        txtCant.ForeColor = vbBlack
        If txtCant.Value <= 0 Then
            lblInfo.Caption = "El valor debe ser mayor que cero"
            txtCant.ForeColor = vbRed
        End If
    Else
        lblInfo.Caption = "El valor debe ser numrico"
        txtCant.ForeColor = vbRed
    End If
End Sub

Private Sub txtCant_Enter()
End Sub

Private Sub txtDiam_Enter()
    txtDiam.Text = Left(txtDiam.Text, Len(txtDiam.Text) - 3)
End Sub

Private Sub txtProf_Enter()
   txtProf.Text = Left(txtProf.Text, Len(txtProf.Text) - 3)
End Sub

Private Sub txtRad_Enter()
   txtRad.Text = Left(txtRad.Text, Len(txtRad.Text) - 3)
End Sub

Private Sub txtRad_BeforeUpdate(ByVal Cancel As MSForms.ReturnBoolean)
    Err.Clear
    On Error Resume Next
    If (oUOM.GetValueFromExpression(txtRad, kDefaultDisplayLengthUnits) < 0 Or Err.Number <> 0) Then
        txtRad.ForeColor = vbRed
        lblInfo.Caption = "El valor debe ser un nmero mayor que cero"
        Cancel = True
    Else
        txtRad.ForeColor = vbBlack
        lblInfo.Caption = ""
        Cancel = False
    End If
End Sub

Private Sub txtRad_Change()
    If IsNumeric(txtRad.Value) Then
        txtRad.ForeColor = vbBlack
        If txtRad.Value <= 0 Then
            lblInfo.Caption = "El valor debe ser mayor que cero"
            txtRad.ForeColor = vbRed
        End If
    Else
        lblInfo.Caption = "El valor debe ser numrico"
        txtRad.ForeColor = vbRed
    End If
End Sub

Private Sub txtRad_Exit(ByVal Cancel As MSForms.ReturnBoolean)
    txtRad.Text = oUOM.GetStringFromValue(oUOM.GetValueFromExpression(txtRad.Text, kDefaultDisplayLengthUnits), kDefaultDisplayLengthUnits)
    txtRad.ForeColor = vbBlack
    lblInfo.Caption = ""
End Sub

Private Sub txtDiam_BeforeUpdate(ByVal Cancel As MSForms.ReturnBoolean)
    Err.Clear
    On Error Resume Next
    If (oUOM.GetValueFromExpression(txtDiam, kDefaultDisplayLengthUnits) < 0 Or Err.Number <> 0) Then
        txtDiam.ForeColor = vbRed
        lblInfo.Caption = "El valor debe ser un nmero mayor que cero"
        Cancel = True
    Else
        txtDiam.ForeColor = vbBlack
        lblInfo.Caption = ""
        Cancel = False
    End If
End Sub

Private Sub txtDiam_Change()
    If IsNumeric(txtDiam.Value) Then
        txtDiam.ForeColor = vbBlack
        If txtDiam.Value <= 0 Then
            lblInfo.Caption = "El valor debe ser mayor que cero"
            txtDiam.ForeColor = vbRed
        End If
    Else
        lblInfo.Caption = "El valor debe ser numrico"
        txtDiam.ForeColor = vbRed
    End If
End Sub

Private Sub txtProf_BeforeUpdate(ByVal Cancel As MSForms.ReturnBoolean)
    Err.Clear
    On Error Resume Next
    If (oUOM.GetValueFromExpression(txtProf, kDefaultDisplayLengthUnits) < 0 Or Err.Number <> 0) Then
        txtProf.ForeColor = vbRed
        lblInfo.Caption = "El valor debe ser un nmero mayor que cero"
        Cancel = True
    Else
        txtProf.ForeColor = vbBlack
        lblInfo.Caption = ""
        Cancel = False
    End If
End Sub

Private Sub txtProf_Change()
    If IsNumeric(txtProf.Value) Then
        txtProf.ForeColor = vbBlack
        If txtProf.Value <= 0 Then
            lblInfo.Caption = "El valor debe ser mayor que cero"
            txtProf.ForeColor = vbRed
        End If
    Else
        lblInfo.Caption = "El valor debe ser numrico"
        txtProf.ForeColor = vbRed
    End If
End Sub

Private Sub txtDiam_Exit(ByVal Cancel As MSForms.ReturnBoolean)
    txtDiam.Text = oUOM.GetStringFromValue(oUOM.GetValueFromExpression(txtDiam.Text, kDefaultDisplayLengthUnits), kDefaultDisplayLengthUnits)
    txtDiam.ForeColor = vbBlack
    lblInfo.Caption = ""
End Sub

Private Sub txtProf_Exit(ByVal Cancel As MSForms.ReturnBoolean)
    txtProf.Text = oUOM.GetStringFromValue(oUOM.GetValueFromExpression(txtProf.Text, kDefaultDisplayLengthUnits), kDefaultDisplayLengthUnits)
    txtProf.ForeColor = vbBlack
    lblInfo.Caption = ""
End Sub

Private Sub UserForm_Initialize()
    Set oDoc = ThisApplication.ActiveDocument
End Sub


Private Sub UserForm_Terminate()

End Sub
